"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const render_1 = require("./render");
const mount_1 = require("./mount");
/** render wrapper */
function _r(props) {
    return render_1.render(this, this.instance, props);
}
/** wrapped mount */
function _wm(options) {
    const target = options === undefined ? undefined : options.target;
    if (target === null)
        return null;
    const targetElement = mount_1._m(this.instance, this, target, options === null || options === void 0 ? void 0 : options.props);
    const els = this.els;
    if (!els.includes(targetElement)) {
        els.push(targetElement);
    }
    return targetElement;
}
/** wrapped _u */
function _wu(options) {
    // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
    const target = !options ? undefined : options.target;
    const delay = options === undefined ? 0 : options.delay === undefined ? 0 : options.delay;
    if (target === null)
        return;
    if (delay === 0)
        mount_1._u(this.instance, this, target);
    else {
        setTimeout(() => mount_1._u(this.instance, this, target), delay);
    }
}
/** create CNode */
function _cc(instance, $, props, children) {
    return {
        instance,
        $,
        props,
        children,
        els: [],
        render: _r,
        mount: _wm,
        unmount: _wu
    };
}
exports.c = function (instance, $, props, children) {
    if (Array.isArray($)) {
        return _cc(instance, '', null, $);
    }
    if (Array.isArray(props)) {
        return _cc(instance, $, null, props);
    }
    else if (Array.isArray(children)) {
        return _cc(instance, $, props, children);
    }
    else {
        return _cc(instance, $, props, null);
    }
};
